Scriptname BloodthirstVampireFeedTracker extends activemagiceffect  

Keyword Property Vampire Auto
Keyword Property ActorTypeUndead Auto
Keyword Property ActorTypeNPC Auto

Idle Property IdleVampireStandingFeedFront_Loose Auto

Actor targetActor = None

bool isFeeding = false
Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
  if (targetActor != None) && ( targetActor.HasKeyword(Vampire) ) && ( isFeeding == false )
	isFeeding = true
	
	Actor aggressorActor = akAggressor as Actor
	if(  aggressorActor != None ) && \
	( ! targetActor.IsDead() ) && \
	 ( ! aggressorActor.HasKeyword(Vampire) )  && \
	 ( ! aggressorActor.HasKeyword(ActorTypeUndead ) )  && \
	 aggressorActor.HasKeyword(ActorTypeNPC ) && \
	 ( aggressorActor.GetDistance( targetActor ) < 110 )   &&  \
	  ( ( targetActor.GetAV("Stamina") ) > ( aggressorActor.GetAV("Stamina")  )   ) && \
	  ( ( targetActor.GetAV("Health") ) > ( aggressorActor.GetAV("Health")  )   )
		targetActor.UnequipItem( targetActor.GetEquippedWeapon() )
		Utility.Wait(0.1)
		if( targetActor.PlayIdleWithTarget( IdleVampireStandingFeedFront_Loose, aggressorActor) )
			; CAN CAUSE THE ALARM? targetActor.StartVampireFeed(aggressorActor)

			if( aggressorActor == Game.GetPlayer() ) && ( ! targetActor.IsInFaction(DLC1VampireCrimeFaction ) )  && ( ! targetActor.IsInFaction(DLC1SeranaFaction) )
				aggressorActor .DoCombatSpellApply(DiseaseSanguinareVampiris , aggressorActor )
			endif

			int healthToTake =  ( targetActor.GetLevel() / 3 )
			if( aggressorActor.GetAV("Health") > healthToTake )
				aggressorActor.DamageAV("Health", healthToTake  )
			endif		

			if( targetActor.GetLevel() > aggressorActor.GetLevel()  )	
				targetActor.ResetHealthAndLimbs()
				Utility.Wait(2)
				BloodthirstBleedFX.Cast(aggressorActor,aggressorActor)
			endif
		endif
		
		Utility.Wait(10)
	endif
	
	isFeeding = false
  endif
EndEvent

SPELL Property BloodthirstBleedFX Auto

SPELL Property DiseaseSanguinareVampiris Auto
Faction Property DLC1VampireCrimeFaction Auto
Faction Property DLC1SeranaFaction Auto

Event OnEffectStart(Actor akTarget, Actor akCaster)
 if (akCaster!= None) && (akCaster!= Game.GetPlayer() ) && ( akCaster.HasKeyword(Vampire) )
	targetActor = akCaster

	targetActor.ClearLookAt()
	Actor resultVictim = None

	float  resultVictimLightLevel = 5000 ; Initial value,  as high as possible
	int attempts = 50
	while( attempts  > 0 ) && ( ! targetActor.IsDead() )  && ( ! targetActor.IsInCombat() )
		Actor newVictimCandidate = Game.FindRandomActorFromRef( targetActor , 3000 )
		Utility.Wait(0.1)

		if( newVictimCandidate != None )
			float candidateLightLevel = newVictimCandidate.GetLightLevel()
			if( VictimIsTasty( targetActor,  newVictimCandidate )  ) && ( candidateLightLevel < resultVictimLightLevel )
				resultVictim = newVictimCandidate 
				resultVictimLightLevel = candidateLightLevel 
			endif
		endif

		attempts -= 1
	endWhile

	if( resultVictim != None )
		targetActor.SetAV("Variable08", 1)

		targetActor.SetLookAt(resultVictim)
		VampireAlias.ForceRefTo( targetActor )
		VictimAlias .ForceRefTo( resultVictim )
	endif
 endif
endEvent

ReferenceAlias Property VampireAlias Auto
ReferenceAlias Property VictimAlias Auto

bool function VictimIsTasty(Actor vampireActor, Actor potentialVictim  )
	if( vampireActor == None ) || ( potentialVictim  == None )
		return false
	endif

	if( vampireActor.GetAV("Morality") > 0  ) && vampireActor.IsPlayerTeammate() && \
	 ( ( potentialVictim == Game.GetPlayer() ) || potentialVictim.IsPlayerTeammate() )
		return false
	endif

	return ( potentialVictim != None ) && ( ! potentialVictim.IsDead() ) && ( ! potentialVictim.IsEssential() )  &&  \
	( ! potentialVictim.IsEssential() )  &&  \
	 ( !  potentialVictim .HasKeyword(Vampire) )  && \ 
	( ! potentialVictim .HasKeyword(ActorTypeUndead ) ) && \
	 potentialVictim .HasKeyword(ActorTypeNPC ) && \
	vampireActor.HasLos( potentialVictim ) && ( ( vampireActor.GetRelationshipRank(potentialVictim ) < 1 ) || ( vampireActor.GetAV("Morality") <= 0  ) ) 
endFunction
